#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators.BobC
{
	public class ADXVMAColorBand : Indicator
	{   private int 		Period 			= 5;
		private double		k				= 0.0;
		private double		hhp				= 0.0;
		private double		llp				= 0.0;
		private double		hhv				= 0.0;
		private double		llv				= 0.0;
		private double 		epsilon			= 0.0;
		private bool		showPlot		= true;
		private bool		showPaintBars	= true;
		private bool		candles			= true;
		private int			opacity			= 4;
		private int			alpha			= 0;
		private int 		plot0Width 		= 4;
		
		private double[] 	up;
		private double[]  	down;
		private double[]  	ups;
		private double[]  	downs;
		
		private Series<double> index;
		private double[] _ADXVMAColorBand;
		private int[]	trend;
		//private ATR volatility; 
		private double[] Volatility;
		private double prevInput=0;
		private int vPeriod=200;
		private double rawRange, trueRange,P1;
		private bool ShowPlot =true;
		private bool LoadFlag=true;
		private DateTime Start;
	    private TimeSpan BackfillTime;
		private int cbr=0;
		//for keltner
		private Series<double>		diff;
		private	SMA					smaDiff;
		private	SMA					smaTypical;
		
		NinjaTrader.Gui.Tools.SimpleFont myFont = new NinjaTrader.Gui.Tools.SimpleFont("Arial", 11) { Size = 11, Bold = false };
		
			
		protected override void OnStateChange()
		{
		#region	Set Defaults and Plots
			if (State == State.SetDefaults)
			{
				Description							= @"adapted from anaADXVMA for NT7";
				Name								= "ADXVMAColorBand";
		//		AddPlot(Brushes.Red, "adx vma 0");
				_Period                             = 5;
				Textoffset 							= 1;
				Calculate							= Calculate.OnPriceChange;
				IsOverlay							= true;
				DisplayInDataBox					= true;
				DrawOnPricePanel					= true;
				DrawHorizontalGridLines				= true;
				DrawVerticalGridLines				= true;
				PaintPriceMarkers					= false;
				ScaleJustification					= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				IsSuspendedWhileInactive			= true;
				OffsetMultiplier					= 1.5;
				OuterOffsetMultiplier				= 2.5;

				AddPlot(Brushes.DarkGray,		NinjaTrader.Custom.Resource.KeltnerChannelMidline);
				AddPlot(Brushes.White,			NinjaTrader.Custom.Resource.NinjaScriptIndicatorUpper);
				AddPlot(Brushes.White,			"OuterUpper");
				AddPlot(Brushes.White,			NinjaTrader.Custom.Resource.NinjaScriptIndicatorLower);
				AddPlot(Brushes.White,			"OuterLower");
				Plots[0].Width = 5;				//adxvma Main
				Plots[1].Width = 1;				//adxvma Upper
				Plots[2].Width = 1;				//adxvma UpperOuter
				Plots[3].Width = 1;				//adxvma Lower
				Plots[4].Width = 1;				//adxvma LowerOuter	
				adxvmaRisingBrush = Brushes.Blue;
				adxvmaFallingBrush = Brushes.Red;
				adxvmaNeutralBrush = Brushes.Yellow;
			}
			else if (State == State.Configure)
			{       Period=_Period;
				    k = Math.Round(1.0/(double)Period,6);
				    up = new double[2];
					down = new double[2];
					ups = new double[2];
					downs = new double[2];
				    trend = new int[2];
					index = new Series<double>(this);
					
					Volatility= new double[2];
					_ADXVMAColorBand=new double[2];
				   
				    Start=Core.Globals.Now;
				    LoadFlag=true;
				    cbr=ChartBars.ToIndex;
				
				diff				= new Series<double>(this);
				smaDiff				= SMA(diff, Period);
				smaTypical			= SMA(Typical, Period);
				
			
			}
		#endregion	
		}
		

		protected override void OnBarUpdate()
		{
			if(!IsFirstTickOfBar && prevInput==Input[0])return;prevInput=Input[0];
		      if(CurrentBar==cbr && LoadFlag)
		    {   LoadFlag=false;	
				BackfillTime=Core.Globals.Now-Start;
				int s=BackfillTime.Seconds;
				int f=BackfillTime.Milliseconds;
				string F=f.ToString("000");
				cbr=CurrentBar;
				string replay="";
				if(IsTickReplays[0]==true) replay=" (Tick Replay Mode) "; else replay =" (Non Tick Replay Mode) ";
			//	Print("ADXVMAColorBand, efficiently coded for NT8 by Zondor, has backfilled "
			//	+CurrentBar.ToString("#,000")	+" bars, on "); 
			//	Print("   "+Bars.BarsPeriod+" chart of "+Instrument.FullName+" "+replay+", in "+s+"."+F
			//	+" seconds."); 
			//	Print(" Thank you for using the ADXVMAColorBand. You are sooo awesome :) .");
				
		    }
		    
			if( CurrentBar < 1 )
			{
				up[0]=(0.0);
				down[0]=(0.0);
				ups[0]=(0.0);
				downs[0]=(0.0);
				index[0]=(0.0);
				trend[0]=(0);
				return;
					
				
			}
			if (CurrentBar <Period)
				{
					Values[0][0]=Median[0]; _ADXVMAColorBand[0]=Median[0]; _ADXVMAColorBand[1]=Median[1];
				}
			else
			{
				//double trueRange = High[0] - Low[0];
				if(IsFirstTickOfBar) 
				 {   up[1]=up[0];       ups[1]=ups[0]; 
				     down[1]=down[0];   downs[1]=downs[0];
					
					 _ADXVMAColorBand[1]         = _ADXVMAColorBand[0];
					 Volatility[1]      = Volatility[0];
					 trend[1]           = trend[0];
				     P1=(vPeriod - 1 ) * Values[0][1];
				     rawRange=High[0]-Low[0];
				     trueRange = Math.Max(Math.Abs(Low[0] - Close[1]), Math.Max(rawRange, Math.Abs(High[0] - Close[1])));
				     Volatility[0]=(P1 + trueRange) / vPeriod;
				 }
			#region Apply Keltner Bands and Outer Bands to ADXVMA	 
			diff[0]				= High[0] - Low[0];
			double middle		= _ADXVMAColorBand[0];
			double offset		= smaDiff[0] * OffsetMultiplier;
			double outeroffset	= smaDiff[0] * OuterOffsetMultiplier;
			double upper		= middle + offset;
			double outerupper	= middle + outeroffset;	 
			double lower		= middle - offset;
			double outerlower	= middle - outeroffset;
				 
			Midline[0]		= middle;
			Upper[0]		= upper;
			OuterUpper[0]	= outerupper;	 
			Lower[0]		= lower;
			OuterLower[0]	= outerlower;
			#endregion	 
		    }
		
		
		
			#region Calculate ADXVMA
			{
				double currentUp = Math.Max(Input[0] - Input[1], 0);
             	double currentDown = Math.Max(Input[1] - Input[0], 0);
			    up[0]= ((1-k)*up[1] + k*currentUp);
				down[0]=((1-k)*down[1] + k*currentDown);
				
				double sum = up[0] + down[0];
				double fractionUp = 0.0;
				double fractionDown = 0.0;
				if(sum > double.Epsilon)
				{
					fractionUp = up[0]/sum;
					fractionDown = down[0]/sum;
				}
				ups[0]=((1-k)*ups[1] + k*fractionUp);
				downs[0]=((1-k)*downs[1] + k*fractionDown);
				
				double normDiff = Math.Abs(ups[0] - downs[0]);
				double normSum = ups[0] + downs[0];
				double normFraction = 0.0;
				if(normSum > double.Epsilon)
					normFraction = normDiff/normSum;
				index[0]=((1-k)*index[1] + k*normFraction);
				
            	if(IsFirstTickOfBar)
				{
					epsilon = 0.1 * Volatility[1];
					hhp = MAX(index,Period)[1];
					llp = MIN(index,Period)[1];
				}	
				hhv = Math.Max(index[0],hhp);
				llv = Math.Min(index[0],llp);
				
				double vDiff = hhv-llv;
				double vIndex = 0;
				if(vDiff > double.Epsilon)
					vIndex = (index[0] - llv)/vDiff;
				
				_ADXVMAColorBand[0]=((1 - k*vIndex)*_ADXVMAColorBand[1] + k*vIndex*Input[0]);
	//		Values[0][0]=_ADXVMAColorBand[0];
		
		 	#region Adjust ADXVMA Line Color and Plot
			
			if (_ADXVMAColorBand[0] > _ADXVMAColorBand[1])
				{PlotBrushes[0][0] = adxvmaRisingBrush;
				Draw.Text(this, "tag1", false, "ADXVMA"+(Period), -Textoffset, _ADXVMAColorBand[0], 0, PlotBrushes[0][0], myFont, TextAlignment.Center, Brushes.Transparent, null, 1);
				}
			else if (_ADXVMAColorBand[0] < _ADXVMAColorBand[1])
				{PlotBrushes[0][0] = adxvmaFallingBrush;
				Draw.Text(this, "tag1", false, "ADXVMA"+(Period), -Textoffset, _ADXVMAColorBand[0], 0, PlotBrushes[0][0], myFont, TextAlignment.Center, Brushes.Transparent, null, 1);
				}	
			else
				{PlotBrushes[0][0] = adxvmaNeutralBrush;
				Draw.Text(this, "tag1", false, "ADXVMA"+(Period), -Textoffset, _ADXVMAColorBand[0], 0, PlotBrushes[0][0], myFont, TextAlignment.Center, Brushes.Transparent, null, 1);
					
			//	Draw.Text(this, "tag1","ADXVMA"+( Period), -Textoffset, _ADXVMAColorBand[0],PlotBrushes[0][0]);
				}		
			#endregion	
			}
			#endregion
		}
			// In order to trim the indicator's label we need to override the ToString() method.
			public override string DisplayName
				{
		            get { return Name + "(" + Period +"_"+OffsetMultiplier +"_"+ OuterOffsetMultiplier+")";}
				}	
		
	#region Properties
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(ResourceType = typeof(Custom.Resource), Name = "Period", GroupName = "NinjaScriptParameters", Order = 0)]
		public int _Period
		{ get; set; }		
	
		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Lower
		{
			get { return Values[3]; }
		}
		
		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> OuterLower
		{
			get { return Values[4]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Midline
		{
			get { return Values[0]; }
		}

		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> Upper
		{
			get { return Values[1]; }
		}
		
		[Browsable(false)]
		[XmlIgnore()]
		public Series<double> OuterUpper
		{
			get { return Values[2]; }
		}
		
		[Range(0.01, int.MaxValue), NinjaScriptProperty]
		[Display(ResourceType = typeof(Custom.Resource), Name = "OffsetMultiplier", GroupName = "NinjaScriptParameters", Order = 0)]
		public double OffsetMultiplier
		{ get; set; }

		[Range(0.01, int.MaxValue), NinjaScriptProperty]	
		[Display(ResourceType = typeof(Custom.Resource), Name = "OuterOffsetMultiplier", GroupName = "NinjaScriptParameters", Order = 0)]
		public double OuterOffsetMultiplier
		{ get; set; }
		
		[XmlIgnore]
		[Display(Name="ADXVMA Rising Color", Description="ADXVMA Line Rising Color", Order=1, GroupName="Colors")]
		public Brush adxvmaRisingBrush
		{ get; set; }

		[Browsable(false)]
		public string adxvmaRisingBrushSerializable
		{
			get { return Serialize.BrushToString(adxvmaRisingBrush); }
			set { adxvmaRisingBrush = Serialize.StringToBrush(value); }
		}			

		[XmlIgnore]
		[Display(Name="ADXVMA Falling Color", Description="ADXVMA Line Falling Color", Order=2, GroupName="Colors")]
		public Brush adxvmaFallingBrush
		{ get; set; }

		[Browsable(false)]
		public string adxvmaFallingBrushSerializable
		{
			get { return Serialize.BrushToString(adxvmaFallingBrush); }
			set { adxvmaFallingBrush = Serialize.StringToBrush(value); }					
		}			
				
		
		[XmlIgnore]
		[Display(Name="ADXVMA Neutral Color", Description="ADXVMA Line Neutral Color", Order=2, GroupName="Colors")]
		public Brush adxvmaNeutralBrush
		{ get; set; }

		[Browsable(false)]
		public string adxvmaNeutralBrushSerializable
		{
			get { return Serialize.BrushToString(adxvmaNeutralBrush); }
			set { adxvmaNeutralBrush = Serialize.StringToBrush(value); }					
		}			
		
		
		
		
		
		[Range(1, int.MaxValue)]
		[Display(Name="TextOffset", Description="Chart Text Offset", Order=1, GroupName="Parameters")]
		public int Textoffset
		{ get; set; }
     #endregion
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private BobC.ADXVMAColorBand[] cacheADXVMAColorBand;
		public BobC.ADXVMAColorBand ADXVMAColorBand(int _period, double offsetMultiplier, double outerOffsetMultiplier)
		{
			return ADXVMAColorBand(Input, _period, offsetMultiplier, outerOffsetMultiplier);
		}

		public BobC.ADXVMAColorBand ADXVMAColorBand(ISeries<double> input, int _period, double offsetMultiplier, double outerOffsetMultiplier)
		{
			if (cacheADXVMAColorBand != null)
				for (int idx = 0; idx < cacheADXVMAColorBand.Length; idx++)
					if (cacheADXVMAColorBand[idx] != null && cacheADXVMAColorBand[idx]._Period == _period && cacheADXVMAColorBand[idx].OffsetMultiplier == offsetMultiplier && cacheADXVMAColorBand[idx].OuterOffsetMultiplier == outerOffsetMultiplier && cacheADXVMAColorBand[idx].EqualsInput(input))
						return cacheADXVMAColorBand[idx];
			return CacheIndicator<BobC.ADXVMAColorBand>(new BobC.ADXVMAColorBand(){ _Period = _period, OffsetMultiplier = offsetMultiplier, OuterOffsetMultiplier = outerOffsetMultiplier }, input, ref cacheADXVMAColorBand);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.BobC.ADXVMAColorBand ADXVMAColorBand(int _period, double offsetMultiplier, double outerOffsetMultiplier)
		{
			return indicator.ADXVMAColorBand(Input, _period, offsetMultiplier, outerOffsetMultiplier);
		}

		public Indicators.BobC.ADXVMAColorBand ADXVMAColorBand(ISeries<double> input , int _period, double offsetMultiplier, double outerOffsetMultiplier)
		{
			return indicator.ADXVMAColorBand(input, _period, offsetMultiplier, outerOffsetMultiplier);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.BobC.ADXVMAColorBand ADXVMAColorBand(int _period, double offsetMultiplier, double outerOffsetMultiplier)
		{
			return indicator.ADXVMAColorBand(Input, _period, offsetMultiplier, outerOffsetMultiplier);
		}

		public Indicators.BobC.ADXVMAColorBand ADXVMAColorBand(ISeries<double> input , int _period, double offsetMultiplier, double outerOffsetMultiplier)
		{
			return indicator.ADXVMAColorBand(input, _period, offsetMultiplier, outerOffsetMultiplier);
		}
	}
}

#endregion
